##############################################################################
#
# Copyright (c) 2008-2009 SIA "KN dati". (http://kndati.lv) All Rights Reserved.
#                    General contacts <info@kndati.lv>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields,osv
import netsvc
import tools
import re
from mx import DateTime
from mx.DateTime import now
import time, locale
import traceback, sys

def find_req_users(self, cr, uid, service):
    result = []
    admin_id = self.pool.get('res.users').search(cr, uid, [('login','=','admin')])[0]
    srv = self.pool.get('inv.service').browse(cr, uid, service, {})
    tgroup = map(int, srv.req_users)
    tg_obj = self.pool.get('hr.timesheet.group')
    for wt in tgroup:
        user = tg_obj.browse(cr, uid, wt, {}).manager.id
        if user not in result:
            result.append(tg_obj.browse(cr, uid, wt, {}).manager.id)
    #emp_obj = self.pool.get('hr.employee')
    #emp_ids = emp_obj.search(cr, uid, [])
    #for id in emp_ids:
    #    emp_rec = emp_obj.browse(cr, uid, id, {})
    #    for r in map(int, srv.req_users):
    #        if r in map(int, emp_rec.workgroups):
    #            user = emp_rec.user_id.id
    #            if user not in result:
    #                result.append(emp_rec.user_id.id)
    if result and result[0]:
        return result
    else:
        return [admin_id]

def create_request(self, cr, uid, subject, req_text, service):
    req_users = find_req_users(self, cr, uid, service)
    for user_id in req_users:
        admin_id = self.pool.get('res.users').search(cr, uid, [('login','=','admin')])[0]
        req_values = {'name':subject,'act_from':admin_id,'act_to':user_id,'date_sent':time.strftime('%Y-%m-%d %H:%M:%S'),'body':req_text,'state':'waiting','priority':'2'}
        id = self.pool.get('res.request').create(cr, uid, req_values)
        cr.execute('select act_from,act_to,body,date_sent from res_request where id=%s', (id,))
        values = cr.dictfetchone()
        if len(values['body']) > 128:
            values['name'] = values['body'][:125] + '...'
        else:
            values['name'] = values['body'] or '/'
        values['req_id'] = id
        self.pool.get('res.request.history').create(cr, uid, values)
    return True

def convert_date(self, date):
    if len(date)==10:
        return date[8:10]+'.'+date[5:7]+'.'+date[:4]+'.'
    elif len(date)==7:
        return date[5:7]+'.'+date[:4]+'.'
    return date+'.'

class method(osv.osv):
    _inherit = "inv.method"
    _name = "inv.method"

    _columns = {}

    def _add_info(self, agr_id, meth_id):
        res = ''
        if agr_id: res += "\nAgreement ID: %s" %  agr_id
        if meth_id: res += "\nMethodology ID: %s" % meth_id
        return res

    def _run_filters(self, cr, uid, ids, agr_id, context={}):
        agr = self.pool.get('inv.agreement')
        r = agr.browse(cr, uid, agr_id, {})
        d_list = self.pool.get('inv.date_list')
        current_date = now().strftime('%Y-%m-%d')
        if r.service.invoicing == 'period':
            full_date_list = map(int, r.date_list)
            date_list1 = d_list.search(cr, uid, [('id','in',full_date_list),('status','=','wait')])
            date_list2 = d_list.search(cr, uid, [('id','in',full_date_list),('status','=','process')])
            date_list = date_list2 + date_list1
            if not date_list: return True
            date_list.reverse()
            date_id = date_list.pop()
            date = d_list.browse(cr, uid, date_id, {}).date
            pdate1 = DateTime.strptime(d_list.browse(cr, uid, date_id, {}).pdate1, '%Y-%m-%d')
            pdate2 = DateTime.strptime(d_list.browse(cr, uid, date_id, {}).pdate2, '%Y-%m-%d')
        else:
            date = current_date
            date_id = False
            pdate1 = False
            pdate2 = False
            date_list = []
        try:
            current_date = now().strftime('%Y-%m-%d')
            if date <= current_date and r.service.invoicing=='period':
                d_list.write(cr, uid, date_id, {'status':'process'})
            if not ids:
                req_body = '- In Service "'+r.service.name+'" Methodologies not defined !'+self._add_info(r.id, False)
                cr.rollback()
                create_request(self, cr, uid, 'Error! Methodologies not defined', req_body, r.service.id)
                cr.commit()
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
            if not r.service.pricelist_id:
                req_body = '- In Service "'+r.service.name+'" Sale Pricelist not defined !'+self._add_info(r.id, False)
                cr.rollback()
                create_request(self, cr, uid, 'Sale Pricelist not defined', req_body, r.service.id)
                cr.commit()
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
            version_obj = self.pool.get('product.pricelist.version')
            if r.service.pricelist_id:
                version_ids = map(int, r.service.pricelist_id.version_id)
                if version_ids:
                    pl_actual = False
                    for plv in version_obj.browse(cr, uid, version_ids, {}):
                        if plv.active:
                            if not plv.date_start and not plv.date_end:
                                pl_actual = True
                                break
                            elif plv.date_start <= current_date and not plv.date_end:
                                pl_actual = True
                                break
                            elif plv.date_start <= current_date and current_date <= plv.date_end:
                                pl_actual = True
                                break
                    if pl_actual:
                        plv_items = map(int, plv.items_id)
                        if not plv_items:
                            req_body = '- In Pricelist "'+r.service.pricelist_id.name+'" product not defined !'+self._add_info(r.id, False)
                            cr.rollback()
                            create_request(self, cr, uid, 'Product not defined', req_body, r.service.id)
                            cr.commit()
                            d_list.write(cr, uid, date_id, {'status':'error'})
                            agr.write(cr, uid, [agr_id], {'state':'error'})
                    else:
                        req_body = 'Pricelist "'+r.service.pricelist_id.name+'" not have actual version or pricelist version not active !'+self._add_info(r.id, False)
                        cr.rollback()
                        create_request(self, cr, uid, 'Sale Pricelist Version not actual', req_body, r.service.id)
                        cr.commit()
                        d_list.write(cr, uid, date_id, {'status':'error'})
                        agr.write(cr, uid, [agr_id], {'state':'error'})
                else:
                    req_body = 'Pricelist "'+r.service.pricelist_id.name+'" does not have a not alone version!'+self._add_info(r.id, False)
                    cr.rollback()
                    create_request(self, cr, uid, 'Sale Pricelist not have version', req_body, r.service.id)
                    cr.commit()
                    d_list.write(cr, uid, date_id, {'status':'error'})
                    agr.write(cr, uid, [agr_id], {'state':'error'})
            if not r.service.req_users:
                req_body = '- In Service "'+r.service.name+'" Work Team not defined !'+self._add_info(r.id, False)
                cr.rollback()
                create_request(self, cr, uid, 'Warning! Work Team not defined', req_body, r.service.id)
                cr.commit()
                #d_list.write(cr, uid, date_id, {'status':'error'})
            if not r.analytic_account:
                req_body = '- In Agreement "'+(r.name or 'id:'+str(r.id)+', number:'+r.number)+'" not select Analytic Account !'
                cr.rollback()
                create_request(self, cr, uid, 'Warning! Not select Analytic Account', req_body, r.service.id)
                cr.commit()
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
            if not r.analytic_account.partner_id:
                req_body = '- In Analytic Account "'+r.analytic_account.name+'" (Agreement: "'+(r.name or r.number or '')+'") Associated partner not defined !'
                cr.rollback()
                create_request(self, cr, uid, 'Warning! Associated partner not defined', req_body, r.service.id)
                cr.commit()
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
            if r.analytic_account.to_invoice and r.analytic_account.to_invoice.factor > 0.0:
                req_body = '- In Analytic Account "'+r.analytic_account.name+'" (Agreement: "'+(r.name or r.number or '')+'") not 100% invoicing !'
                cr.rollback()
                create_request(self, cr, uid, 'Warning! Not 100% invoicing', req_body, r.service.id)
                cr.commit()
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
            if not r.repeat:
                req_body = '- In Agreement "'+(r.name or 'id:'+str(r.id)+', number:'+r.number)+'" not check Repead missed !'
                cr.rollback()
                create_request(self, cr, uid, 'Warning! Not check Repead missed', req_body, r.service.id)
                cr.commit()
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
            for p in self.browse(cr, uid, ids, {}):
                mas_after = []
                localspace = {"self":self,"cr":cr,"uid":uid,"re":re,"mas_aft":mas_after,"partner_id":r.partner_id.id,"contact_ids":map(int, r.partner_id.address),"pdate1":pdate1,"pdate2":pdate2,"invoice_date":date,"agre":r}
                exec p.source in localspace
                mas_after = localspace['mas_aft']
                if not mas_after and r.service.invoicing!='trigger':
                    req_body = '- Agreement: "'+(r.name or 'id:'+str(r.id)+', number:'+r.number)+'"\n- Methodology: "'+p.name+'"\n- Filter result: False'+self._add_info(r.id, p.id)
                    cr.rollback()
                    create_request(self, cr, uid, 'Warning! Filter result is False', req_body, r.service.id)
                    cr.commit()
                    d_list.write(cr, uid, date_id, {'status':'error'})
                    agr.write(cr, uid, [agr_id], {'state':'error'})
                if len(mas_after) > 0:
                    calc_ids = map(int, p.calc_ids)
                    calc_seq = self.sort_calc_list(cr, uid, calc_ids)
                    if not calc_seq:
                        req_body = 'In methodology '+p.name+' calculations is not defined!'+self._add_info(r.id, p.id)
                        create_request(self, cr, uid, 'Calculations is not defined!', req_body, r.service.id)
                        d_list.write(cr, uid, date_id, {'status':'error'})
                        agr.write(cr, uid, [agr_id], {'state':'error'})
                    calc_res = False
                    for c_id in calc_seq:
                        c = self.pool.get('inv.calc').browse(cr, uid, c_id, {})
                        #if c.var == 'count':
                        calc_localspace = {"self":self,"cr":cr,"uid":uid,"re":re,"obj_ids":mas_after,"count":len(mas_after),"pdate1":pdate1,"pdate2":pdate2,"calc_date":date,"agre":r}
                        exec c.code in calc_localspace
                        pos = 0
                        for result in calc_localspace['res_list']:
                            if result:
                                calc_res = True
                                line = {"agr_id":agr_id,"user_id":uid,"amount":0}
                                # Analityc Entries, field Description
                                if c.description == 'empty':
                                    line['name'] = ' '
                                elif c.description == 'date':
                                    line['name'] = convert_date(self, current_date)
                                elif c.description == 'period':
                                    period = d_list.browse(cr, uid, date_id, {}).period
                                    line['name'] = period
                                elif c.description == 'field' and c.descr_field:
                                    line['name'] = ''
                                    #for rec_id in mas_after:
                                    rec_id = mas_after[pos]
                                    localspace = {"self":self,"cr":cr,"uid":uid,"model":p.model_id.model,"rec_id":rec_id,"pdate1":pdate1,"pdate2":pdate2,"calc_date":date,'d_list':d_list,"agre":r}
                                    cr.execute("SELECT ttype, relation FROM ir_model_fields WHERE name='"+c.descr_field.name+"' and model='"+p.model_id.model+"'")
                                    query_res = cr.fetchone()
                                    if query_res[0] == 'many2one':
                                        field_value = "ids = self.pool.get('"+p.model_id.model+"').browse(cr, uid, rec_id, {})."+c.descr_field.name+".id\n"
                                        field_value += "field_val = self.pool.get('"+query_res[1]+"').name_get(cr, uid, [ids], {})"
                                    elif query_res[0] == 'one2many' or query_res[0] == 'many2many':
                                        field_value = "ids = map(int, self.pool.get('"+p.model_id.model+"').browse(cr, uid, rec_id, {})."+c.descr_field.name+")\n"
                                        field_value += "field_val = self.pool.get('"+query_res[1]+"').name_get(cr, uid, ids, {})"
                                    else:
                                        field_value = "field_val = self.pool.get('"+p.model_id.model+"').browse(cr, uid, rec_id, {})."+c.descr_field.name
                                    exec field_value in localspace
                                    if query_res[0] == 'many2one' or query_res[0] == 'one2many' or query_res[0] == 'many2many':
                                        res = ''
                                        for n in localspace['field_val']:
                                            if n != localspace['field_val'][0]:
                                                res += '; '
                                            if n[1][0]!='(' and n[1][-1]!=')':
                                                name = "'"+n[1]+"'"
                                            else:
                                                name = n[1]
                                            temp = 'name='+name
                                            exec temp in localspace
                                            if type(localspace['name'])==tuple:
                                                res += localspace['name'][0][1]
                                            else:
                                                res += localspace['name']
                                        line['name'] += res
                                    else:
                                        line['name'] += str(localspace['field_val'])
                                    #if rec_id!=mas_after[-1] and localspace['field_val']: line['name'] += '; '

                                elif c.description == 'expression':
                                    if (c.descr_express).find('rec_id') != -1:
                                        line['name'] = ''
                                        #for x in mas_after:
                                        rec_id = mas_after[pos]
                                        localspace = {"self":self,"cr":cr,"uid":uid,"model":p.model_id.model,"rec_id":rec_id,"agr_id":r.id,"meth_id":p.id,"calc_id":c.id,"desc":'', \
                                            'convert_date':convert_date,'now':now,'d_list':d_list,'date_id':date_id,'pdate1':pdate1,'pdate2':pdate2,"calc_date":date,"agre":r}
                                        exec c.descr_express in localspace
                                        if type(localspace['desc'])==list:
                                            for l in localspace['desc']:
                                                line['name'] += l[1]
                                                if l != localspace['desc'][-1]: line['name'] += '; '
                                        else:
                                            line['name'] += localspace['desc']
                                        #if rec_id!=mas_after[-1]: line['name'] += '; '
                                    else:
                                        rec_id = mas_after[pos]
                                        localspace = {"self":self,"cr":cr,"uid":uid,"model":p.model_id.model,"rec_id":rec_id,"agr_id":r.id,"meth_id":p.id,"calc_id":c.id,"desc":'','convert_date':convert_date,'now':now,'d_list':d_list,'date_id':date_id,'pdate1':pdate1,'pdate2':pdate2,"calc_date":date,"agre":r}
                                        exec c.descr_express in localspace
                                        line['name'] = localspace['desc']
                                else:
                                    line['name'] = ' '
                                # Analityc Entries, field Quantity
                                if c.quantity == 'eqone':
                                    line['unit_amount'] = 1
                                elif c.quantity == 'count':
                                    line['unit_amount'] = len(mas_after)
                                elif c.quantity == 'expression' or c.quantity == 'field':
                                    if (c.quantity_express).find('rec_id') != -1:
                                        line['unit_amount'] = 0
                                        #for rec_id in mas_after:
                                        rec_id = mas_after[pos]
                                        localspace = {"self":self,"cr":cr,"uid":uid,"model":p.model_id.model,"rec_id":rec_id,"agr_id":r.id,"meth_id":p.id,"calc_id":c.id,"pdate1":pdate1,"pdate2":pdate2,"calc_date":date,"agre":r,"quant":''}
                                        exec c.quantity_express in localspace
                                        if type(localspace['quant'])==list:
                                            for l in localspace['quant']:
                                                line['unit_amount'] += l[1]
                                        else:
                                            line['unit_amount'] = localspace['quant']
                                    else:
                                        rec_id = mas_after[pos]
                                        localspace = {"self":self,"cr":cr,"uid":uid,"model":p.model_id.model,"rec_id":rec_id,'mas_after':mas_after,"agr_id":r.id,"meth_id":p.id,"calc_id":c.id,"pdate1":pdate1,"pdate2":pdate2,"calc_date":date,"agre":r,"quant":''}
                                        exec c.quantity_express in localspace
                                        line['unit_amount'] = localspace['quant']
                                else:
                                    line['unit_amount'] = 0
                                # Analityc Entries, field Analytic Account
                                line['account_id'] = r.analytic_account.id
                                # Analityc Entries, field Analytic journal
                                line['journal_id'] = r.service.journal_id.id
                                # Analityc Entries, field General account
                                #if r.partner_id.property_account_receivable:
                                line['general_account_id'] = c.product_id.product_tmpl_id.property_account_expense.id or c.product_id.categ_id.property_account_expense_categ.id
                                if not line['general_account_id']:
                                    req_body = 'There is no expense account define for this product: "%s" (id:%s)' % (c.product_id.name, c.product_id.id,)+self._add_info(r.id, p.id)
                                    cr.rollback()
                                    create_request(self, cr, uid, 'Expense account is not defined', req_body, r.service.id)
                                    cr.commit()
                                    d_list.write(cr, uid, date_id, {'status':'error'})
                                    agr.write(cr, uid, [agr_id], {'state':'error'})
                                # Analityc Entries, field Product
                                line['product_id'] = c.product_id.id
                                # Analityc Entries, field Product UoM
                                line['product_uom_id'] = c.product_id.uom_id.id
                                # Analityc Entries, field Invoicing
                                line['to_invoice'] = c.invoicing_id.id
                                if r.service.purch_pricelist_id:
                                    ppl = r.service.purch_pricelist_id.id
                                    line['amount'] = -self.pool.get('product.pricelist').price_get(cr, uid, [ppl], line['product_id'], line['unit_amount'] or 1.0, r.partner_id.id)[ppl]
                                if r.service.invoicing == 'trigger':
                                    cr.rollback()
                                    date_id = d_list.create(cr, uid, {'agreement_id':r.id,'status':'inv','date':date,'state':'filled'})
                                    cr.commit()
                                    line['invlog_id'] = date_id
                                    self.pool.get('account.analytic.line').create(cr, uid, line)
                                else: line['invlog_id'] = date_id
                                if date <= current_date and r.service.invoicing=='period':
                                    cr.rollback()
                                    self.pool.get('account.analytic.line').create(cr, uid, line)
                                    d_list.write(cr, uid, date_id, {'status':'inv'})
                                    cr.commit()
                            pos += 1
                    if not calc_res and calc_seq:
                        req_body = '- Methodology: '+p.name+'\n- Calculation:\n'+c.code+'\n- Calculation result: False'+self._add_info(r.id, p.id)
                        create_request(self, cr, uid, 'Calculation result is False', req_body, r.service.id)
                        d_list.write(cr, uid, date_id, {'status':'error'})
                        agr.write(cr, uid, [agr_id], {'state':'error'})

        except Exception, e:
            cr.rollback()
            if date <= current_date and r.service.invoicing=='period':
                d_list.write(cr, uid, date_id, {'status':'error'})
                agr.write(cr, uid, [agr_id], {'state':'error'})
                cr.commit()
            tb_s = reduce(lambda x, y: x+y, traceback.format_exception(sys.exc_type, sys.exc_value, sys.exc_traceback))
            create_request(self, cr, uid, 'Error in executed code', tb_s, r.service.id)
        return True

method()

